import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.Random;

/**
  *
  * Klasse fr einen intelligenten Computerspieler
  *
  * @version 1.0 vom 10.08.2008
  * @author Daniel Garmann
  */

public class ComputerSpieler extends Spieler {


  private int suchtiefe;
  private Zug zug;
  private Gui owner;


  public ComputerSpieler(Gui owner, int maximaleSuchtiefe)
  {
    this.owner = owner;
    this.suchtiefe = maximaleSuchtiefe;
  }
  
  private int bewertungsfunktion(Position position)
  { int reihen[][] = position.reihenAnzahl();
    int result =  //reihen[position.amZug()][4]*2000-
           reihen[position.amZug()][3]*2000+
           reihen[position.amZug()][2]*500+
           reihen[position.amZug()][1]*10+
           reihen[position.amZug()][0]*1
           -reihen[1-position.amZug()][4]*5000
           -reihen[1-position.amZug()][3]*1000
           -reihen[1-position.amZug()][2]*100
           -reihen[1-position.amZug()][1]*50
           -reihen[1-position.amZug()][0]*2;


     return result;
  }

  private int negamax(Position position, int tiefe, int alpha, int beta)
  {
    if (position.spielendeErreicht() || (tiefe < 1)) {
  //    if (position.spielendeErreicht()) System.out.println("gewonnen!"+bewertungsfunktion(position));
      return bewertungsfunktion(position);
    } else {
      Zug probezug;
      //int wert = alpha;
      for (int probezugx = 0; probezugx < position.MAX(); probezugx++)
      for (int probezugy = 0; probezugy < position.MAX(); probezugy++) {
        probezug = new Zug(probezugx, probezugy);
        if (position.zulaessig(probezug)) {
          Position folgeposition = position.folgePosition(probezug);
          int folgewert = -negamax(folgeposition, tiefe - 1, -beta, -alpha);
          if (tiefe == suchtiefe)
                        owner.bewertungsausgabe(position, probezug,folgewert);

          if (folgewert > alpha) {
            alpha = folgewert;
            if (tiefe == suchtiefe){
              zug = new Zug (probezug.x(),probezug.y());
            }
            if (folgewert >= beta)
              return beta;
          }
        }
      }
      return alpha;
    }
  }
  


  public Zug spielzugMachen(Position position)
  {
    int wert = negamax(position,suchtiefe, -Integer.MAX_VALUE, Integer.MAX_VALUE);
    JOptionPane.showConfirmDialog(owner,"","",JOptionPane.OK_OPTION,JOptionPane.QUESTION_MESSAGE);
    return zug;
  }

}
