import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

/**
  *
  * Beschreibung
  *
  * @version 1.0 vom 10.08.2008
  * @author Daniel Garmann
  */

public class Gui extends JFrame {
  // Anfang Attribute
  private Spiel spiel;
  
  private JLabel jLabel3 = new JLabel();
  private JTextField jTextFieldAmZug = new JTextField();
  private JButton jButton1 = new JButton();
  private JPanel jPanelAusgabe = new JPanel();
  // Ende Attribute

  public Gui(String title) {
    // Frame-Initialisierung
    super (title);
    setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
    int frameWidth = 468;
    int frameHeight = 391;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2;
    setLocation(100, 100); // setLocation(x, y);
    Container cp = getContentPane();
    cp.setLayout(null);
    // Anfang Komponenten

    jLabel3.setBounds(104, 304, 46, 16);
    jLabel3.setText("dran ist:");
    jLabel3.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLabel3);
    jTextFieldAmZug.setBounds(168, 304, 89, 24);
    jTextFieldAmZug.setText("0");
    cp.add(jTextFieldAmZug);
    jButton1.setBounds(16, 304, 75, 25);
    jButton1.setText("Starten");
    jButton1.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jButton1_ActionPerformed(evt);
      }
    });
    cp.add(jButton1);
    jPanelAusgabe.setBounds(16, 8, 146, 146);
    cp.add(jPanelAusgabe);
    // Ende Komponenten

    setResizable(false);
    setVisible(true);
  }

  // Anfang Methoden
  public void jButton1_ActionPerformed(ActionEvent evt) {
    // Start des Spiels
    spiel = new Spiel(Integer.parseInt(jTextFieldAmZug.getText()),this);
    spiel.starten();
  }


  public void ausgabe(Position position)
  {
    int size = jPanelAusgabe.getBounds().width / position.MAX();
    Graphics g = jPanelAusgabe.getGraphics();
    for (int s = 0; s < position.MAX(); s++){
      for (int z = 0; z < position.MAX(); z++) {
        if (position.feld(s,z) == 0)
          g.setColor(Color.BLUE);
        else if (position.feld(s,z) == 1)
          g.setColor(Color.RED);
        else
          g.setColor(Color.WHITE);
        g.fillOval(s*size,z*size,size,size);
      }
    }
  }
  
  public void ausgabe(Position position, Zug zug){
    this.ausgabe(position);
    int size = jPanelAusgabe.getBounds().width / position.MAX();
    Graphics g = jPanelAusgabe.getGraphics();
    if (position.amZug() == 1)
          g.setColor(Color.BLUE.darker());
    else
          g.setColor(Color.RED.darker());
    g.fillOval(zug.x()*size,zug.y()*size,size,size);

  }
  
  public void bewertungsausgabe(Position position, Zug zug, int bewertung) {
    int size = jPanelAusgabe.getBounds().width / position.MAX();
    Graphics g = jPanelAusgabe.getGraphics();

    g.drawString(""+bewertung,zug.x()*size,zug.y()*size+10);

  }
  // Ende Methoden

  public static void main(String[] args) {
    new Gui("Gui");

  }
}
