/**
  *
  * Beschreibung
  *
  * @version 1.0 vom 10.08.2008
  * @author Daniel Garmann
  */

public class Position {
  private final int MAX = 6;

  private int[][] spielfeld;
  private int amZug;

  public Position()
  {
    spielfeld = new int[MAX][MAX];
    for(int i = 0; i<MAX; i++)
      for (int j = 0; j<MAX; j++)
        spielfeld[i][j]=-1;
    amZug = 0;
  }
  
  public Position(int amZug) {
    this();
    this.amZug = amZug;
  }
  
  public Position(int amZug, int[][] spielfeld)
  {
    this.amZug = amZug;
    this.spielfeld = new int[MAX][MAX];
    for (int x = 0; x < MAX; x++) for (int y = 0; y < MAX; y++) this.spielfeld[x][y] = spielfeld[x][y];
  }

  public int[][] feld()
  {
    return spielfeld;
  }

  public int feld(int x, int y)
  {
    return spielfeld[x][y];
  }


  public int amZug()
  {
    return amZug;
  }
  
  public void zugAusfuehren(Zug zug)
  {
    spielfeld[zug.x()][zug.y()] = amZug;
    amZug = 1 - amZug;
    
  }
  
  public boolean zulaessig(Zug zug)
  {
      if ( (spielfeld[zug.x()][zug.y()] == -1) &&
           (zug.x()>=0) && (zug.x()< MAX) &&
           (zug.y()>=0) && (zug.y()< MAX) )
        return true;
      else
        return false;
  }
  
  public Position folgePosition(Zug zug)
  {
    Position result = new Position(this.amZug, this.spielfeld);
    result.zugAusfuehren(zug);
    return result;
  }
  
  public boolean gewonnen() {
    int[][] reihen = reihenAnzahl();
    
    return (reihen[0][4] > 0) || (reihen[1][4] > 0);
  }
  
  public boolean spielendeErreicht()
  {
      return gewonnen();
  }
  
  public int MAX() {
    return MAX;
  }

  public int[][] reihenAnzahl(){

    int[][] reihen = new int[2][5];
    for (int p=0; p<2; p++) for (int r=0; r<5; r++) reihen[p][r] = 0;

    for (int z = 0; z < MAX; z++) {
      int anz = 0;
      int sp = -2;
      for (int s =0; s < MAX; s++) {
         if (spielfeld[s][z] == sp) {
           anz++;
         } else {
           if ((sp >=0) && (anz > 0)) {
             if (anz > 5) anz = 5;
             reihen[sp][anz-1]++;
           }
           sp = spielfeld[s][z];
           anz = 1;
         }
      }
      if ((sp >=0) && (anz > 0)) {
        if (anz > 5) anz = 5;
        reihen[sp][anz-1]++;
      }

    }

    for (int s = 0; s < MAX; s++) {
      int anz = 0;
      int sp = -2;
      for (int z =0; z < MAX; z++) {
         if (spielfeld[s][z] == sp) {
           anz++;
         } else {
           if ((sp >=0) && (anz > 0)) {
             if (anz > 5) anz = 5;
             reihen[sp][anz-1]++;
           }
           sp = spielfeld[s][z];
           anz = 1;
         }
      }
      if ((sp >=0) && (anz > 0)) {
        if (anz > 5) anz = 5;
        reihen[sp][anz-1]++;
      }
    }

    for (int i = 0; i < 2*MAX-1; i++) {
      int anz = 0;
      int sp = -2;
      int s;
      int z;
      for (int sz =0; sz < 2*MAX-1; sz++) {
         z = sz-MAX+i;
         s = sz;
         if ((s>=0) && (s<MAX) &&
             (z>=0) && (z<MAX)) {
           if (spielfeld[s][z] == sp) {
             anz++;
           } else {
             if ((sp >=0) && (anz > 0)) {
               if (anz > 5) anz = 5;
               reihen[sp][anz-1]++;
             }
             sp = spielfeld[s][z];
             anz = 1;
           }
        }
      }
      if ((sp >=0) && (anz > 0)) {
        if (anz > 5) anz = 5;
        reihen[sp][anz-1]++;
      }
    }


      for (int i = 0; i < 2*MAX-1; i++) {
      int anz = 0;
      int sp = -2;
      int s;
      int z;
      for (int sz =0; sz < 2*MAX-1; sz++) {
         z = i-sz;
         s = sz;
         if ((s>=0) && (s<MAX) &&
             (z>=0) && (z<MAX)) {
           if (spielfeld[s][z] == sp) {
             anz++;
//               System.out.println("s: "+s+"    z: "+z+"  anz:"+anz+"  sp:"+sp);
           } else {
//             System.out.println("wechsel s: "+s+"    z: "+z+"  anz:"+anz+"  sp:"+sp);
             if ((sp >=0) && (anz > 0)) {
               if (anz > 5) anz = 5;
               reihen[sp][anz-1]++;
//               System.out.println("eintrag: s: "+s+"    z: "+z+"  anz:"+anz+"  sp:"+sp);
             }
             sp = spielfeld[s][z];
             anz = 1;
//               System.out.println("s: "+s+"    z: "+z+"  anz:"+anz+"  sp:"+sp);
           }
        }
      }
      if ((sp >=0) && (anz > 0)) {
        if (anz > 5) anz = 5;
        reihen[sp][anz-1]++;
      }

    }


    return reihen;
  }
  
}
